D2xxManager

com.ftdi.j2xx

## Class D2xxManager

- java.lang.Object
- - com.ftdi.j2xx.D2xxManager

-     public class D2xxManager
      extends java.lang.Object

  A management class for connected FTDI devices. Use `getInstance(Context)` to get a copy of D2xxManager; use `createDeviceInfoList(Context)` method to scan current connected FTDI devices, then open target device via a suitable open API.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `D2xxManager.D2xxException` A class for exception debug Handle exception and print error message
    `static class` | `D2xxManager.DriverParameters` A class for read() parameters.
    `static class` | `D2xxManager.FtDeviceInfoListNode` Information about a connected FTDI device.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---

    `static byte`

    `FT_BI`
    Line status bits :
    OE: `FT_OE`,
    PE: `FT_PE`,
    FE: `FT_FE`,
    BI: `FT_BI`

    `static byte`

    `FT_BITMODE_ASYNC_BITBANG`
    Bit Mode bits :
    Reset: `FT_BITMODE_RESET`,
    Asynchronous Bit Bang (FT232B, FT2232, FT232H, FT2232H, FT4232H): `FT_BITMODE_ASYNC_BITBANG`,
    MPSSE (FT2232, FT2232H, FT4232H and FT232H devices only) : `FT_BITMODE_MPSSE`,
    Synchronous Bit Bang (FT232R, FT245R, FT2232, FT2232H, FT4232H and FT232H devices only) : `FT_BITMODE_SYNC_BITBANG`,
    MCU Host Bus Emulation Mode (FT2232, FT2232H, and FT232H devices only) : `FT_BITMODE_MCU_HOST`,
    Fast Opto-Isolated Serial Mode (FT2232, FT2232H, and FT232H devices only) : `FT_BITMODE_FAST_SERIAL`,
    CBUS Bit Bang Mode (FT232R and FT232H devices only) : `FT_BITMODE_CBUS_BITBANG`,
    Single Channel Synchronous 245 FIFO Mode (FT2232H and FT232H devices only) : `FT_BITMODE_SYNC_FIFO`

    `static byte`

    `FT_BITMODE_CBUS_BITBANG`
    Bit Mode bits :
    Reset: `FT_BITMODE_RESET`,
    Asynchronous Bit Bang (FT232B, FT2232, FT232H, FT2232H, FT4232H): `FT_BITMODE_ASYNC_BITBANG`,
    MPSSE (FT2232, FT2232H, FT4232H and FT232H devices only) : `FT_BITMODE_MPSSE`,
    Synchronous Bit Bang (FT232R, FT245R, FT2232, FT2232H, FT4232H and FT232H devices only) : `FT_BITMODE_SYNC_BITBANG`,
    MCU Host Bus Emulation Mode (FT2232, FT2232H, and FT232H devices only) : `FT_BITMODE_MCU_HOST`,
    Fast Opto-Isolated Serial Mode (FT2232, FT2232H, and FT232H devices only) : `FT_BITMODE_FAST_SERIAL`,
    CBUS Bit Bang Mode (FT232R and FT232H devices only) : `FT_BITMODE_CBUS_BITBANG`,
    Single Channel Synchronous 245 FIFO Mode (FT2232H and FT232H devices only) : `FT_BITMODE_SYNC_FIFO`

    `static byte`

    `FT_BITMODE_FAST_SERIAL`
    Bit Mode bits :
    Reset: `FT_BITMODE_RESET`,
    Asynchronous Bit Bang (FT232B, FT2232, FT232H, FT2232H, FT4232H): `FT_BITMODE_ASYNC_BITBANG`,
    MPSSE (FT2232, FT2232H, FT4232H and FT232H devices only) : `FT_BITMODE_MPSSE`,
    Synchronous Bit Bang (FT232R, FT245R, FT2232, FT2232H, FT4232H and FT232H devices only) : `FT_BITMODE_SYNC_BITBANG`,
    MCU Host Bus Emulation Mode (FT2232, FT2232H, and FT232H devices only) : `FT_BITMODE_MCU_HOST`,
    Fast Opto-Isolated Serial Mode (FT2232, FT2232H, and FT232H devices only) : `FT_BITMODE_FAST_SERIAL`,
    CBUS Bit Bang Mode (FT232R and FT232H devices only) : `FT_BITMODE_CBUS_BITBANG`,
    Single Channel Synchronous 245 FIFO Mode (FT2232H and FT232H devices only) : `FT_BITMODE_SYNC_FIFO`

    `static byte`

    `FT_BITMODE_MCU_HOST`
    Bit Mode bits :
    Reset: `FT_BITMODE_RESET`,
    Asynchronous Bit Bang (FT232B, FT2232, FT232H, FT2232H, FT4232H): `FT_BITMODE_ASYNC_BITBANG`,
    MPSSE (FT2232, FT2232H, FT4232H and FT232H devices only) : `FT_BITMODE_MPSSE`,
    Synchronous Bit Bang (FT232R, FT245R, FT2232, FT2232H, FT4232H and FT232H devices only) : `FT_BITMODE_SYNC_BITBANG`,
    MCU Host Bus Emulation Mode (FT2232, FT2232H, and FT232H devices only) : `FT_BITMODE_MCU_HOST`,
    Fast Opto-Isolated Serial Mode (FT2232, FT2232H, and FT232H devices only) : `FT_BITMODE_FAST_SERIAL`,
    CBUS Bit Bang Mode (FT232R and FT232H devices only) : `FT_BITMODE_CBUS_BITBANG`,
    Single Channel Synchronous 245 FIFO Mode (FT2232H and FT232H devices only) : `FT_BITMODE_SYNC_FIFO`

    `static byte`

    `FT_BITMODE_MPSSE`
    Bit Mode bits :
    Reset: `FT_BITMODE_RESET`,
    Asynchronous Bit Bang (FT232B, FT2232, FT232H, FT2232H, FT4232H): `FT_BITMODE_ASYNC_BITBANG`,
    MPSSE (FT2232, FT2232H, FT4232H and FT232H devices only) : `FT_BITMODE_MPSSE`,
    Synchronous Bit Bang (FT232R, FT245R, FT2232, FT2232H, FT4232H and FT232H devices only) : `FT_BITMODE_SYNC_BITBANG`,
    MCU Host Bus Emulation Mode (FT2232, FT2232H, and FT232H devices only) : `FT_BITMODE_MCU_HOST`,
    Fast Opto-Isolated Serial Mode (FT2232, FT2232H, and FT232H devices only) : `FT_BITMODE_FAST_SERIAL`,
    CBUS Bit Bang Mode (FT232R and FT232H devices only) : `FT_BITMODE_CBUS_BITBANG`,
    Single Channel Synchronous 245 FIFO Mode (FT2232H and FT232H devices only) : `FT_BITMODE_SYNC_FIFO`

    `static byte`

    `FT_BITMODE_RESET`
    Bit Mode bits :
    Reset: `FT_BITMODE_RESET`,
    Asynchronous Bit Bang (FT232B, FT2232, FT232H, FT2232H, FT4232H): `FT_BITMODE_ASYNC_BITBANG`,
    MPSSE (FT2232, FT2232H, FT4232H and FT232H devices only) : `FT_BITMODE_MPSSE`,
    Synchronous Bit Bang (FT232R, FT245R, FT2232, FT2232H, FT4232H and FT232H devices only) : `FT_BITMODE_SYNC_BITBANG`,
    MCU Host Bus Emulation Mode (FT2232, FT2232H, and FT232H devices only) : `FT_BITMODE_MCU_HOST`,
    Fast Opto-Isolated Serial Mode (FT2232, FT2232H, and FT232H devices only) : `FT_BITMODE_FAST_SERIAL`,
    CBUS Bit Bang Mode (FT232R and FT232H devices only) : `FT_BITMODE_CBUS_BITBANG`,
    Single Channel Synchronous 245 FIFO Mode (FT2232H and FT232H devices only) : `FT_BITMODE_SYNC_FIFO`

    `static byte`

    `FT_BITMODE_SYNC_BITBANG`
    Bit Mode bits :
    Reset: `FT_BITMODE_RESET`,
    Asynchronous Bit Bang (FT232B, FT2232, FT232H, FT2232H, FT4232H): `FT_BITMODE_ASYNC_BITBANG`,
    MPSSE (FT2232, FT2232H, FT4232H and FT232H devices only) : `FT_BITMODE_MPSSE`,
    Synchronous Bit Bang (FT232R, FT245R, FT2232, FT2232H, FT4232H and FT232H devices only) : `FT_BITMODE_SYNC_BITBANG`,
    MCU Host Bus Emulation Mode (FT2232, FT2232H, and FT232H devices only) : `FT_BITMODE_MCU_HOST`,
    Fast Opto-Isolated Serial Mode (FT2232, FT2232H, and FT232H devices only) : `FT_BITMODE_FAST_SERIAL`,
    CBUS Bit Bang Mode (FT232R and FT232H devices only) : `FT_BITMODE_CBUS_BITBANG`,
    Single Channel Synchronous 245 FIFO Mode (FT2232H and FT232H devices only) : `FT_BITMODE_SYNC_FIFO`

    `static byte`

    `FT_BITMODE_SYNC_FIFO`
    Bit Mode bits :
    Reset: `FT_BITMODE_RESET`,
    Asynchronous Bit Bang (FT232B, FT2232, FT232H, FT2232H, FT4232H): `FT_BITMODE_ASYNC_BITBANG`,
    MPSSE (FT2232, FT2232H, FT4232H and FT232H devices only) : `FT_BITMODE_MPSSE`,
    Synchronous Bit Bang (FT232R, FT245R, FT2232, FT2232H, FT4232H and FT232H devices only) : `FT_BITMODE_SYNC_BITBANG`,
    MCU Host Bus Emulation Mode (FT2232, FT2232H, and FT232H devices only) : `FT_BITMODE_MCU_HOST`,
    Fast Opto-Isolated Serial Mode (FT2232, FT2232H, and FT232H devices only) : `FT_BITMODE_FAST_SERIAL`,
    CBUS Bit Bang Mode (FT232R and FT232H devices only) : `FT_BITMODE_CBUS_BITBANG`,
    Single Channel Synchronous 245 FIFO Mode (FT2232H and FT232H devices only) : `FT_BITMODE_SYNC_FIFO`

    `static byte`

    `FT_CTS`
    Modem status bits :
    CTS: `FT_CTS`,
    DSR: `FT_DSR`,
    RI: `FT_RI`,
    DCD: `FT_DCD`

    `static byte` | `FT_DATA_BITS_7` Data bits : 7 : `FT_DATA_BITS_7`, 8 : `FT_DATA_BITS_8`
    `static byte` | `FT_DATA_BITS_8` Data bits : 7 : `FT_DATA_BITS_7`, 8 : `FT_DATA_BITS_8`

    `static byte`

    `FT_DCD`
    Modem status bits :
    CTS: `FT_CTS`,
    DSR: `FT_DSR`,
    RI: `FT_RI`,
    DCD: `FT_DCD`

    `static int`

    `FT_DEVICE_2232`
    Device Type :
    bvdDevice = 0x0200 or 0x0400 and iSerialNumber != 0: `FT_DEVICE_232B`,
    bvdDevice = 0x0200 and iSerialNumber != 0 : `FT_DEVICE_8U232AM`,
    Unknown : `FT_DEVICE_UNKNOWN`,
    bvdDevice = 0x0500 : `FT_DEVICE_2232`,
    bvdDevice = 0x0600 : `FT_DEVICE_232R`,
    bvdDevice = 0x0600 : `FT_DEVICE_245R`,
    bvdDevice = 0x0700 : `FT_DEVICE_2232H`,
    bvdDevice = 0x0800 : `FT_DEVICE_4232H`,
    bvdDevice = 0x0900 : `FT_DEVICE_232H`,
    bvdDevice = 0x1000 : `FT_DEVICE_X_SERIES`
    bvdDevice = 0x1800 : `#FT_DEVICE_4222`
    bvdDevice = 0x1900 : `#FT_DEVICE_4222`
    bvdDevice = 0x1700 : `#FT_DEVICE_4222`

    `static int`

    `FT_DEVICE_2232H`
    Device Type :
    bvdDevice = 0x0200 or 0x0400 and iSerialNumber != 0: `FT_DEVICE_232B`,
    bvdDevice = 0x0200 and iSerialNumber != 0 : `FT_DEVICE_8U232AM`,
    Unknown : `FT_DEVICE_UNKNOWN`,
    bvdDevice = 0x0500 : `FT_DEVICE_2232`,
    bvdDevice = 0x0600 : `FT_DEVICE_232R`,
    bvdDevice = 0x0600 : `FT_DEVICE_245R`,
    bvdDevice = 0x0700 : `FT_DEVICE_2232H`,
    bvdDevice = 0x0800 : `FT_DEVICE_4232H`,
    bvdDevice = 0x0900 : `FT_DEVICE_232H`,
    bvdDevice = 0x1000 : `FT_DEVICE_X_SERIES`
    bvdDevice = 0x1800 : `#FT_DEVICE_4222`
    bvdDevice = 0x1900 : `#FT_DEVICE_4222`
    bvdDevice = 0x1700 : `#FT_DEVICE_4222`

    `static int`

    `FT_DEVICE_232B`
    Device Type :
    bvdDevice = 0x0200 or 0x0400 and iSerialNumber != 0: `FT_DEVICE_232B`,
    bvdDevice = 0x0200 and iSerialNumber != 0 : `FT_DEVICE_8U232AM`,
    Unknown : `FT_DEVICE_UNKNOWN`,
    bvdDevice = 0x0500 : `FT_DEVICE_2232`,
    bvdDevice = 0x0600 : `FT_DEVICE_232R`,
    bvdDevice = 0x0600 : `FT_DEVICE_245R`,
    bvdDevice = 0x0700 : `FT_DEVICE_2232H`,
    bvdDevice = 0x0800 : `FT_DEVICE_4232H`,
    bvdDevice = 0x0900 : `FT_DEVICE_232H`,
    bvdDevice = 0x1000 : `FT_DEVICE_X_SERIES`
    bvdDevice = 0x1800 : `#FT_DEVICE_4222`
    bvdDevice = 0x1900 : `#FT_DEVICE_4222`
    bvdDevice = 0x1700 : `#FT_DEVICE_4222`

    `static int`

    `FT_DEVICE_232H`
    Device Type :
    bvdDevice = 0x0200 or 0x0400 and iSerialNumber != 0: `FT_DEVICE_232B`,
    bvdDevice = 0x0200 and iSerialNumber != 0 : `FT_DEVICE_8U232AM`,
    Unknown : `FT_DEVICE_UNKNOWN`,
    bvdDevice = 0x0500 : `FT_DEVICE_2232`,
    bvdDevice = 0x0600 : `FT_DEVICE_232R`,
    bvdDevice = 0x0600 : `FT_DEVICE_245R`,
    bvdDevice = 0x0700 : `FT_DEVICE_2232H`,
    bvdDevice = 0x0800 : `FT_DEVICE_4232H`,
    bvdDevice = 0x0900 : `FT_DEVICE_232H`,
    bvdDevice = 0x1000 : `FT_DEVICE_X_SERIES`
    bvdDevice = 0x1800 : `#FT_DEVICE_4222`
    bvdDevice = 0x1900 : `#FT_DEVICE_4222`
    bvdDevice = 0x1700 : `#FT_DEVICE_4222`

    `static int`

    `FT_DEVICE_232R`
    Device Type :
    bvdDevice = 0x0200 or 0x0400 and iSerialNumber != 0: `FT_DEVICE_232B`,
    bvdDevice = 0x0200 and iSerialNumber != 0 : `FT_DEVICE_8U232AM`,
    Unknown : `FT_DEVICE_UNKNOWN`,
    bvdDevice = 0x0500 : `FT_DEVICE_2232`,
    bvdDevice = 0x0600 : `FT_DEVICE_232R`,
    bvdDevice = 0x0600 : `FT_DEVICE_245R`,
    bvdDevice = 0x0700 : `FT_DEVICE_2232H`,
    bvdDevice = 0x0800 : `FT_DEVICE_4232H`,
    bvdDevice = 0x0900 : `FT_DEVICE_232H`,
    bvdDevice = 0x1000 : `FT_DEVICE_X_SERIES`
    bvdDevice = 0x1800 : `#FT_DEVICE_4222`
    bvdDevice = 0x1900 : `#FT_DEVICE_4222`
    bvdDevice = 0x1700 : `#FT_DEVICE_4222`

    `static int`

    `FT_DEVICE_245R`
    Device Type :
    bvdDevice = 0x0200 or 0x0400 and iSerialNumber != 0: `FT_DEVICE_232B`,
    bvdDevice = 0x0200 and iSerialNumber != 0 : `FT_DEVICE_8U232AM`,
    Unknown : `FT_DEVICE_UNKNOWN`,
    bvdDevice = 0x0500 : `FT_DEVICE_2232`,
    bvdDevice = 0x0600 : `FT_DEVICE_232R`,
    bvdDevice = 0x0600 : `FT_DEVICE_245R`,
    bvdDevice = 0x0700 : `FT_DEVICE_2232H`,
    bvdDevice = 0x0800 : `FT_DEVICE_4232H`,
    bvdDevice = 0x0900 : `FT_DEVICE_232H`,
    bvdDevice = 0x1000 : `FT_DEVICE_X_SERIES`
    bvdDevice = 0x1800 : `#FT_DEVICE_4222`
    bvdDevice = 0x1900 : `#FT_DEVICE_4222`
    bvdDevice = 0x1700 : `#FT_DEVICE_4222`

    `static int`

    `FT_DEVICE_4222_0`
    Device Type :
    bvdDevice = 0x0200 or 0x0400 and iSerialNumber != 0: `FT_DEVICE_232B`,
    bvdDevice = 0x0200 and iSerialNumber != 0 : `FT_DEVICE_8U232AM`,
    Unknown : `FT_DEVICE_UNKNOWN`,
    bvdDevice = 0x0500 : `FT_DEVICE_2232`,
    bvdDevice = 0x0600 : `FT_DEVICE_232R`,
    bvdDevice = 0x0600 : `FT_DEVICE_245R`,
    bvdDevice = 0x0700 : `FT_DEVICE_2232H`,
    bvdDevice = 0x0800 : `FT_DEVICE_4232H`,
    bvdDevice = 0x0900 : `FT_DEVICE_232H`,
    bvdDevice = 0x1000 : `FT_DEVICE_X_SERIES`
    bvdDevice = 0x1800 : `#FT_DEVICE_4222`
    bvdDevice = 0x1900 : `#FT_DEVICE_4222`
    bvdDevice = 0x1700 : `#FT_DEVICE_4222`

    `static int`

    `FT_DEVICE_4222_1_2`
    Device Type :
    bvdDevice = 0x0200 or 0x0400 and iSerialNumber != 0: `FT_DEVICE_232B`,
    bvdDevice = 0x0200 and iSerialNumber != 0 : `FT_DEVICE_8U232AM`,
    Unknown : `FT_DEVICE_UNKNOWN`,
    bvdDevice = 0x0500 : `FT_DEVICE_2232`,
    bvdDevice = 0x0600 : `FT_DEVICE_232R`,
    bvdDevice = 0x0600 : `FT_DEVICE_245R`,
    bvdDevice = 0x0700 : `FT_DEVICE_2232H`,
    bvdDevice = 0x0800 : `FT_DEVICE_4232H`,
    bvdDevice = 0x0900 : `FT_DEVICE_232H`,
    bvdDevice = 0x1000 : `FT_DEVICE_X_SERIES`
    bvdDevice = 0x1800 : `#FT_DEVICE_4222`
    bvdDevice = 0x1900 : `#FT_DEVICE_4222`
    bvdDevice = 0x1700 : `#FT_DEVICE_4222`

    `static int`

    `FT_DEVICE_4222_3`
    Device Type :
    bvdDevice = 0x0200 or 0x0400 and iSerialNumber != 0: `FT_DEVICE_232B`,
    bvdDevice = 0x0200 and iSerialNumber != 0 : `FT_DEVICE_8U232AM`,
    Unknown : `FT_DEVICE_UNKNOWN`,
    bvdDevice = 0x0500 : `FT_DEVICE_2232`,
    bvdDevice = 0x0600 : `FT_DEVICE_232R`,
    bvdDevice = 0x0600 : `FT_DEVICE_245R`,
    bvdDevice = 0x0700 : `FT_DEVICE_2232H`,
    bvdDevice = 0x0800 : `FT_DEVICE_4232H`,
    bvdDevice = 0x0900 : `FT_DEVICE_232H`,
    bvdDevice = 0x1000 : `FT_DEVICE_X_SERIES`
    bvdDevice = 0x1800 : `#FT_DEVICE_4222`
    bvdDevice = 0x1900 : `#FT_DEVICE_4222`
    bvdDevice = 0x1700 : `#FT_DEVICE_4222`

    `static int`

    `FT_DEVICE_4232H`
    Device Type :
    bvdDevice = 0x0200 or 0x0400 and iSerialNumber != 0: `FT_DEVICE_232B`,
    bvdDevice = 0x0200 and iSerialNumber != 0 : `FT_DEVICE_8U232AM`,
    Unknown : `FT_DEVICE_UNKNOWN`,
    bvdDevice = 0x0500 : `FT_DEVICE_2232`,
    bvdDevice = 0x0600 : `FT_DEVICE_232R`,
    bvdDevice = 0x0600 : `FT_DEVICE_245R`,
    bvdDevice = 0x0700 : `FT_DEVICE_2232H`,
    bvdDevice = 0x0800 : `FT_DEVICE_4232H`,
    bvdDevice = 0x0900 : `FT_DEVICE_232H`,
    bvdDevice = 0x1000 : `FT_DEVICE_X_SERIES`
    bvdDevice = 0x1800 : `#FT_DEVICE_4222`
    bvdDevice = 0x1900 : `#FT_DEVICE_4222`
    bvdDevice = 0x1700 : `#FT_DEVICE_4222`

    `static int`

    `FT_DEVICE_8U232AM`
    Device Type :
    bvdDevice = 0x0200 or 0x0400 and iSerialNumber != 0: `FT_DEVICE_232B`,
    bvdDevice = 0x0200 and iSerialNumber != 0 : `FT_DEVICE_8U232AM`,
    Unknown : `FT_DEVICE_UNKNOWN`,
    bvdDevice = 0x0500 : `FT_DEVICE_2232`,
    bvdDevice = 0x0600 : `FT_DEVICE_232R`,
    bvdDevice = 0x0600 : `FT_DEVICE_245R`,
    bvdDevice = 0x0700 : `FT_DEVICE_2232H`,
    bvdDevice = 0x0800 : `FT_DEVICE_4232H`,
    bvdDevice = 0x0900 : `FT_DEVICE_232H`,
    bvdDevice = 0x1000 : `FT_DEVICE_X_SERIES`
    bvdDevice = 0x1800 : `#FT_DEVICE_4222`
    bvdDevice = 0x1900 : `#FT_DEVICE_4222`
    bvdDevice = 0x1700 : `#FT_DEVICE_4222`

    `static int`

    `FT_DEVICE_UNKNOWN`
    Device Type :
    bvdDevice = 0x0200 or 0x0400 and iSerialNumber != 0: `FT_DEVICE_232B`,
    bvdDevice = 0x0200 and iSerialNumber != 0 : `FT_DEVICE_8U232AM`,
    Unknown : `FT_DEVICE_UNKNOWN`,
    bvdDevice = 0x0500 : `FT_DEVICE_2232`,
    bvdDevice = 0x0600 : `FT_DEVICE_232R`,
    bvdDevice = 0x0600 : `FT_DEVICE_245R`,
    bvdDevice = 0x0700 : `FT_DEVICE_2232H`,
    bvdDevice = 0x0800 : `FT_DEVICE_4232H`,
    bvdDevice = 0x0900 : `FT_DEVICE_232H`,
    bvdDevice = 0x1000 : `FT_DEVICE_X_SERIES`
    bvdDevice = 0x1800 : `#FT_DEVICE_4222`
    bvdDevice = 0x1900 : `#FT_DEVICE_4222`
    bvdDevice = 0x1700 : `#FT_DEVICE_4222`

    `static int`

    `FT_DEVICE_X_SERIES`
    Device Type :
    bvdDevice = 0x0200 or 0x0400 and iSerialNumber != 0: `FT_DEVICE_232B`,
    bvdDevice = 0x0200 and iSerialNumber != 0 : `FT_DEVICE_8U232AM`,
    Unknown : `FT_DEVICE_UNKNOWN`,
    bvdDevice = 0x0500 : `FT_DEVICE_2232`,
    bvdDevice = 0x0600 : `FT_DEVICE_232R`,
    bvdDevice = 0x0600 : `FT_DEVICE_245R`,
    bvdDevice = 0x0700 : `FT_DEVICE_2232H`,
    bvdDevice = 0x0800 : `FT_DEVICE_4232H`,
    bvdDevice = 0x0900 : `FT_DEVICE_232H`,
    bvdDevice = 0x1000 : `FT_DEVICE_X_SERIES`
    bvdDevice = 0x1800 : `#FT_DEVICE_4222`
    bvdDevice = 0x1900 : `#FT_DEVICE_4222`
    bvdDevice = 0x1700 : `#FT_DEVICE_4222`

    `static byte`

    `FT_DSR`
    Modem status bits :
    CTS: `FT_CTS`,
    DSR: `FT_DSR`,
    RI: `FT_RI`,
    DCD: `FT_DCD`

    `static byte`

    `FT_EVENT_LINE_STATUS`
    Event bits :
    Rx Char Event: `FT_EVENT_RXCHAR`,
    Modem Status Event: `FT_EVENT_MODEM_STATUS`,
    Line Status Event: `FT_EVENT_LINE_STATUS`,
    Removed Event: `FT_EVENT_REMOVED`

    `static byte`

    `FT_EVENT_MODEM_STATUS`
    Event bits :
    Rx Char Event: `FT_EVENT_RXCHAR`,
    Modem Status Event: `FT_EVENT_MODEM_STATUS`,
    Line Status Event: `FT_EVENT_LINE_STATUS`,
    Removed Event: `FT_EVENT_REMOVED`

    `static byte`

    `FT_EVENT_REMOVED`
    Event bits :
    Rx Char Event: `FT_EVENT_RXCHAR`,
    Modem Status Event: `FT_EVENT_MODEM_STATUS`,
    Line Status Event: `FT_EVENT_LINE_STATUS`,
    Removed Event: `FT_EVENT_REMOVED`

    `static byte`

    `FT_EVENT_RXCHAR`
    Event bits :
    Rx Char Event: `FT_EVENT_RXCHAR`,
    Modem Status Event: `FT_EVENT_MODEM_STATUS`,
    Line Status Event: `FT_EVENT_LINE_STATUS`,
    Removed Event: `FT_EVENT_REMOVED`

    `static byte`

    `FT_FE`
    Line status bits :
    OE: `FT_OE`,
    PE: `FT_PE`,
    FE: `FT_FE`,
    BI: `FT_BI`

    `static byte` | `FT_FLAGS_HI_SPEED` Device info list flags : Device Open Flag: `FT_FLAGS_OPENED`, Device Hi Speed Flag: `FT_FLAGS_HI_SPEED`
    `static byte` | `FT_FLAGS_OPENED` Device info list flags : Device Open Flag: `FT_FLAGS_OPENED`, Device Hi Speed Flag: `FT_FLAGS_HI_SPEED`

    `static short`

    `FT_FLOW_DTR_DSR`
    Flow Control bits :
    None: `FT_FLOW_NONE`,
    CTS/RTS: `FT_FLOW_RTS_CTS`,
    DTR/DSR: `FT_FLOW_DTR_DSR`,
    XON/XOFF: `FT_FLOW_XON_XOFF`

    `static short`

    `FT_FLOW_NONE`
    Flow Control bits :
    None: `FT_FLOW_NONE`,
    CTS/RTS: `FT_FLOW_RTS_CTS`,
    DTR/DSR: `FT_FLOW_DTR_DSR`,
    XON/XOFF: `FT_FLOW_XON_XOFF`

    `static short`

    `FT_FLOW_RTS_CTS`
    Flow Control bits :
    None: `FT_FLOW_NONE`,
    CTS/RTS: `FT_FLOW_RTS_CTS`,
    DTR/DSR: `FT_FLOW_DTR_DSR`,
    XON/XOFF: `FT_FLOW_XON_XOFF`

    `static short`

    `FT_FLOW_XON_XOFF`
    Flow Control bits :
    None: `FT_FLOW_NONE`,
    CTS/RTS: `FT_FLOW_RTS_CTS`,
    DTR/DSR: `FT_FLOW_DTR_DSR`,
    XON/XOFF: `FT_FLOW_XON_XOFF`

    `static byte`

    `FT_OE`
    Line status bits :
    OE: `FT_OE`,
    PE: `FT_PE`,
    FE: `FT_FE`,
    BI: `FT_BI`

    `static byte`

    `FT_PARITY_EVEN`
    Parity bits, used by App :
    None: `FT_PARITY_NONE`,
    Odd: `FT_PARITY_ODD`,
    Even: `FT_PARITY_EVEN`,
    Mark: `FT_PARITY_MARK`,
    Space: `FT_PARITY_SPACE`

    `static byte`

    `FT_PARITY_MARK`
    Parity bits, used by App :
    None: `FT_PARITY_NONE`,
    Odd: `FT_PARITY_ODD`,
    Even: `FT_PARITY_EVEN`,
    Mark: `FT_PARITY_MARK`,
    Space: `FT_PARITY_SPACE`

    `static byte`

    `FT_PARITY_NONE`
    Parity bits, used by App :
    None: `FT_PARITY_NONE`,
    Odd: `FT_PARITY_ODD`,
    Even: `FT_PARITY_EVEN`,
    Mark: `FT_PARITY_MARK`,
    Space: `FT_PARITY_SPACE`

    `static byte`

    `FT_PARITY_ODD`
    Parity bits, used by App :
    None: `FT_PARITY_NONE`,
    Odd: `FT_PARITY_ODD`,
    Even: `FT_PARITY_EVEN`,
    Mark: `FT_PARITY_MARK`,
    Space: `FT_PARITY_SPACE`

    `static byte`

    `FT_PARITY_SPACE`
    Parity bits, used by App :
    None: `FT_PARITY_NONE`,
    Odd: `FT_PARITY_ODD`,
    Even: `FT_PARITY_EVEN`,
    Mark: `FT_PARITY_MARK`,
    Space: `FT_PARITY_SPACE`

    `static byte`

    `FT_PE`
    Line status bits :
    OE: `FT_OE`,
    PE: `FT_PE`,
    FE: `FT_FE`,
    BI: `FT_BI`

    `static byte` | `FT_PURGE_RX` Purge flags : RX purge flag: `FT_PURGE_RX`, TX purge flag: `FT_PURGE_TX`
    `static byte` | `FT_PURGE_TX` Purge flags : RX purge flag: `FT_PURGE_RX`, TX purge flag: `FT_PURGE_TX`

    `static byte`

    `FT_RI`
    Modem status bits :
    CTS: `FT_CTS`,
    DSR: `FT_DSR`,
    RI: `FT_RI`,
    DCD: `FT_DCD`

    `static byte` | `FT_STOP_BITS_1` Stop bits : 1: `FT_STOP_BITS_1`, 2: `FT_STOP_BITS_2`,
    `static byte` | `FT_STOP_BITS_2` Stop bits : 1: `FT_STOP_BITS_1`, 2: `FT_STOP_BITS_2`,
    `static int` | `FTDI_BREAK_OFF` BREAK on is bit 14 in wValue parameter of FTDI_SET_DATA request : UART break on condition: `FTDI_BREAK_OFF`, UART break off condition: `FTDI_BREAK_ON`
    `static int` | `FTDI_BREAK_ON` BREAK on is bit 14 in wValue parameter of FTDI_SET_DATA request : UART break on condition: `FTDI_BREAK_OFF`, UART break off condition: `FTDI_BREAK_ON`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `addUsbDevice(UsbDevice dev)` This method analyze the dev passed-in, if it's a FTDI device, add it to manageable device list
    `int` | `createDeviceInfoList(Context parentContext)` This method builds an internal device information list and returns the number of D2XX devices connected to the system.
    `int` | `getDeviceInfoList(int numDevs, D2xxManager.FtDeviceInfoListNode[] deviceList)` This method returns the device list created with a prior call to `createDeviceInfoList(Context)`.
    `D2xxManager.FtDeviceInfoListNode` | `getDeviceInfoListDetail(int index)` This method returns information for a single device from the internal device list created by a previous call to `createDeviceInfoList(Context)`.
    `static D2xxManager` | `getInstance(Context parentContext)` This method initialises an application, obtaining a value of D2xx device manager.
    `static int` | `getLibraryVersion()` This method returns the D2XX library version number.
    `int[][]` | `getVIDPID()` This retrieves the current VID and PID combination from within the internal device list table.
    `boolean` | `isFtDevice(UsbDevice dev)` This queries if a plugged-in USB device is a valid FT_Device
    `FT_Device` | `openByDescription(Context parentContext, java.lang.String description)` This designates the device with the specified description.
    `FT_Device` | `openByDescription(Context parentContext, java.lang.String description, D2xxManager.DriverParameters params)` This designates the device with the specified description and allows for configuration of driver parameters.
    `FT_Device` | `openByIndex(Context parentContext, int index)` This designates the device at the specified index.
    `FT_Device` | `openByIndex(Context parentContext, int index, D2xxManager.DriverParameters params)` This designates the device at the specified index and allows for configuration of driver parameters.
    `FT_Device` | `openByLocation(Context parentContext, int location)` This designates the device at the specified location.
    `FT_Device` | `openByLocation(Context parentContext, int location, D2xxManager.DriverParameters params)` This designates the device at the specified location, and allows for configuration of driver parameters.
    `FT_Device` | `openBySerialNumber(Context parentContext, java.lang.String serialNumber)` This designates the device with the specified serial number.
    `FT_Device` | `openBySerialNumber(Context parentContext, java.lang.String serialNumber, D2xxManager.DriverParameters params)` This designates the device with the specified serial number for use, and allows for configuration of driver parameters.
    `FT_Device` | `openByUsbDevice(Context parentContext, UsbDevice dev)` This designates the device from the specified USB Device object..
    `FT_Device` | `openByUsbDevice(Context parentContext, UsbDevice dev, D2xxManager.DriverParameters params)` This designates the device from the specified USB Device object, and allows for configuration of driver parameters.
    `boolean` | `setVIDPID(int vendorId, int productId)` This allows a custom VID and PID combination within the internal device list table.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### FT_DATA_BITS_7

          public static final byte FT_DATA_BITS_7

      Data bits :
      7 : `FT_DATA_BITS_7`,
      8 : `FT_DATA_BITS_8`
      See Also:
        Constant Field Values

    - #### FT_DATA_BITS_8

          public static final byte FT_DATA_BITS_8

      Data bits :
      7 : `FT_DATA_BITS_7`,
      8 : `FT_DATA_BITS_8`
      See Also:
        Constant Field Values

    - #### FT_STOP_BITS_1

          public static final byte FT_STOP_BITS_1

      Stop bits :
      1: `FT_STOP_BITS_1`,
      2: `FT_STOP_BITS_2`,
      See Also:
        Constant Field Values

    - #### FT_STOP_BITS_2

          public static final byte FT_STOP_BITS_2

      Stop bits :
      1: `FT_STOP_BITS_1`,
      2: `FT_STOP_BITS_2`,
      See Also:
        Constant Field Values

    - #### FT_PARITY_NONE

          public static final byte FT_PARITY_NONE

      Parity bits, used by App :
      None: `FT_PARITY_NONE`,
      Odd: `FT_PARITY_ODD`,
      Even: `FT_PARITY_EVEN`,
      Mark: `FT_PARITY_MARK`,
      Space: `FT_PARITY_SPACE`
      See Also:
        Constant Field Values

    - #### FT_PARITY_ODD

          public static final byte FT_PARITY_ODD

      Parity bits, used by App :
      None: `FT_PARITY_NONE`,
      Odd: `FT_PARITY_ODD`,
      Even: `FT_PARITY_EVEN`,
      Mark: `FT_PARITY_MARK`,
      Space: `FT_PARITY_SPACE`
      See Also:
        Constant Field Values

    - #### FT_PARITY_EVEN

          public static final byte FT_PARITY_EVEN

      Parity bits, used by App :
      None: `FT_PARITY_NONE`,
      Odd: `FT_PARITY_ODD`,
      Even: `FT_PARITY_EVEN`,
      Mark: `FT_PARITY_MARK`,
      Space: `FT_PARITY_SPACE`
      See Also:
        Constant Field Values

    - #### FT_PARITY_MARK

          public static final byte FT_PARITY_MARK

      Parity bits, used by App :
      None: `FT_PARITY_NONE`,
      Odd: `FT_PARITY_ODD`,
      Even: `FT_PARITY_EVEN`,
      Mark: `FT_PARITY_MARK`,
      Space: `FT_PARITY_SPACE`
      See Also:
        Constant Field Values

    - #### FT_PARITY_SPACE

          public static final byte FT_PARITY_SPACE

      Parity bits, used by App :
      None: `FT_PARITY_NONE`,
      Odd: `FT_PARITY_ODD`,
      Even: `FT_PARITY_EVEN`,
      Mark: `FT_PARITY_MARK`,
      Space: `FT_PARITY_SPACE`
      See Also:
        Constant Field Values

    - #### FT_FLOW_NONE

          public static final short FT_FLOW_NONE

      Flow Control bits :
      None: `FT_FLOW_NONE`,
      CTS/RTS: `FT_FLOW_RTS_CTS`,
      DTR/DSR: `FT_FLOW_DTR_DSR`,
      XON/XOFF: `FT_FLOW_XON_XOFF`
      See Also:
        Constant Field Values

    - #### FT_FLOW_RTS_CTS

          public static final short FT_FLOW_RTS_CTS

      Flow Control bits :
      None: `FT_FLOW_NONE`,
      CTS/RTS: `FT_FLOW_RTS_CTS`,
      DTR/DSR: `FT_FLOW_DTR_DSR`,
      XON/XOFF: `FT_FLOW_XON_XOFF`
      See Also:
        Constant Field Values

    - #### FT_FLOW_DTR_DSR

          public static final short FT_FLOW_DTR_DSR

      Flow Control bits :
      None: `FT_FLOW_NONE`,
      CTS/RTS: `FT_FLOW_RTS_CTS`,
      DTR/DSR: `FT_FLOW_DTR_DSR`,
      XON/XOFF: `FT_FLOW_XON_XOFF`
      See Also:
        Constant Field Values

    - #### FT_FLOW_XON_XOFF

          public static final short FT_FLOW_XON_XOFF

      Flow Control bits :
      None: `FT_FLOW_NONE`,
      CTS/RTS: `FT_FLOW_RTS_CTS`,
      DTR/DSR: `FT_FLOW_DTR_DSR`,
      XON/XOFF: `FT_FLOW_XON_XOFF`
      See Also:
        Constant Field Values

    - #### FT_PURGE_RX

          public static final byte FT_PURGE_RX

      Purge flags :
      RX purge flag: `FT_PURGE_RX`,
      TX purge flag: `FT_PURGE_TX`
      See Also:
        Constant Field Values

    - #### FT_PURGE_TX

          public static final byte FT_PURGE_TX

      Purge flags :
      RX purge flag: `FT_PURGE_RX`,
      TX purge flag: `FT_PURGE_TX`
      See Also:
        Constant Field Values

    - #### FT_CTS

          public static final byte FT_CTS

      Modem status bits :
      CTS: `FT_CTS`,
      DSR: `FT_DSR`,
      RI: `FT_RI`,
      DCD: `FT_DCD`
      See Also:
        Constant Field Values

    - #### FT_DSR

          public static final byte FT_DSR

      Modem status bits :
      CTS: `FT_CTS`,
      DSR: `FT_DSR`,
      RI: `FT_RI`,
      DCD: `FT_DCD`
      See Also:
        Constant Field Values

    - #### FT_RI

          public static final byte FT_RI

      Modem status bits :
      CTS: `FT_CTS`,
      DSR: `FT_DSR`,
      RI: `FT_RI`,
      DCD: `FT_DCD`
      See Also:
        Constant Field Values

    - #### FT_DCD

          public static final byte FT_DCD

      Modem status bits :
      CTS: `FT_CTS`,
      DSR: `FT_DSR`,
      RI: `FT_RI`,
      DCD: `FT_DCD`
      See Also:
        Constant Field Values

    - #### FT_OE

          public static final byte FT_OE

      Line status bits :
      OE: `FT_OE`,
      PE: `FT_PE`,
      FE: `FT_FE`,
      BI: `FT_BI`
      See Also:
        Constant Field Values

    - #### FT_PE

          public static final byte FT_PE

      Line status bits :
      OE: `FT_OE`,
      PE: `FT_PE`,
      FE: `FT_FE`,
      BI: `FT_BI`
      See Also:
        Constant Field Values

    - #### FT_FE

          public static final byte FT_FE

      Line status bits :
      OE: `FT_OE`,
      PE: `FT_PE`,
      FE: `FT_FE`,
      BI: `FT_BI`
      See Also:
        Constant Field Values

    - #### FT_BI

          public static final byte FT_BI

      Line status bits :
      OE: `FT_OE`,
      PE: `FT_PE`,
      FE: `FT_FE`,
      BI: `FT_BI`
      See Also:
        Constant Field Values

    - #### FT_EVENT_RXCHAR

          public static final byte FT_EVENT_RXCHAR

      Event bits :
      Rx Char Event: `FT_EVENT_RXCHAR`,
      Modem Status Event: `FT_EVENT_MODEM_STATUS`,
      Line Status Event: `FT_EVENT_LINE_STATUS`,
      Removed Event: `FT_EVENT_REMOVED`
      See Also:
        Constant Field Values

    - #### FT_EVENT_MODEM_STATUS

          public static final byte FT_EVENT_MODEM_STATUS

      Event bits :
      Rx Char Event: `FT_EVENT_RXCHAR`,
      Modem Status Event: `FT_EVENT_MODEM_STATUS`,
      Line Status Event: `FT_EVENT_LINE_STATUS`,
      Removed Event: `FT_EVENT_REMOVED`
      See Also:
        Constant Field Values

    - #### FT_EVENT_LINE_STATUS

          public static final byte FT_EVENT_LINE_STATUS

      Event bits :
      Rx Char Event: `FT_EVENT_RXCHAR`,
      Modem Status Event: `FT_EVENT_MODEM_STATUS`,
      Line Status Event: `FT_EVENT_LINE_STATUS`,
      Removed Event: `FT_EVENT_REMOVED`
      See Also:
        Constant Field Values

    - #### FT_EVENT_REMOVED

          public static final byte FT_EVENT_REMOVED

      Event bits :
      Rx Char Event: `FT_EVENT_RXCHAR`,
      Modem Status Event: `FT_EVENT_MODEM_STATUS`,
      Line Status Event: `FT_EVENT_LINE_STATUS`,
      Removed Event: `FT_EVENT_REMOVED`
      See Also:
        Constant Field Values

    - #### FT_FLAGS_OPENED

          public static final byte FT_FLAGS_OPENED

      Device info list flags :
      Device Open Flag: `FT_FLAGS_OPENED`,
      Device Hi Speed Flag: `FT_FLAGS_HI_SPEED`
      See Also:
        Constant Field Values

    - #### FT_FLAGS_HI_SPEED

          public static final byte FT_FLAGS_HI_SPEED

      Device info list flags :
      Device Open Flag: `FT_FLAGS_OPENED`,
      Device Hi Speed Flag: `FT_FLAGS_HI_SPEED`
      See Also:
        Constant Field Values

    - #### FT_DEVICE_232B

          public static final int FT_DEVICE_232B

      Device Type :
      bvdDevice = 0x0200 or 0x0400 and iSerialNumber != 0: `FT_DEVICE_232B`,
      bvdDevice = 0x0200 and iSerialNumber != 0 : `FT_DEVICE_8U232AM`,
      Unknown : `FT_DEVICE_UNKNOWN`,
      bvdDevice = 0x0500 : `FT_DEVICE_2232`,
      bvdDevice = 0x0600 : `FT_DEVICE_232R`,
      bvdDevice = 0x0600 : `FT_DEVICE_245R`,
      bvdDevice = 0x0700 : `FT_DEVICE_2232H`,
      bvdDevice = 0x0800 : `FT_DEVICE_4232H`,
      bvdDevice = 0x0900 : `FT_DEVICE_232H`,
      bvdDevice = 0x1000 : `FT_DEVICE_X_SERIES`
      bvdDevice = 0x1800 : `#FT_DEVICE_4222`
      bvdDevice = 0x1900 : `#FT_DEVICE_4222`
      bvdDevice = 0x1700 : `#FT_DEVICE_4222`
      See Also:
        Constant Field Values

    - #### FT_DEVICE_8U232AM

          public static final int FT_DEVICE_8U232AM

      Device Type :
      bvdDevice = 0x0200 or 0x0400 and iSerialNumber != 0: `FT_DEVICE_232B`,
      bvdDevice = 0x0200 and iSerialNumber != 0 : `FT_DEVICE_8U232AM`,
      Unknown : `FT_DEVICE_UNKNOWN`,
      bvdDevice = 0x0500 : `FT_DEVICE_2232`,
      bvdDevice = 0x0600 : `FT_DEVICE_232R`,
      bvdDevice = 0x0600 : `FT_DEVICE_245R`,
      bvdDevice = 0x0700 : `FT_DEVICE_2232H`,
      bvdDevice = 0x0800 : `FT_DEVICE_4232H`,
      bvdDevice = 0x0900 : `FT_DEVICE_232H`,
      bvdDevice = 0x1000 : `FT_DEVICE_X_SERIES`
      bvdDevice = 0x1800 : `#FT_DEVICE_4222`
      bvdDevice = 0x1900 : `#FT_DEVICE_4222`
      bvdDevice = 0x1700 : `#FT_DEVICE_4222`
      See Also:
        Constant Field Values

    - #### FT_DEVICE_UNKNOWN

          public static final int FT_DEVICE_UNKNOWN

      Device Type :
      bvdDevice = 0x0200 or 0x0400 and iSerialNumber != 0: `FT_DEVICE_232B`,
      bvdDevice = 0x0200 and iSerialNumber != 0 : `FT_DEVICE_8U232AM`,
      Unknown : `FT_DEVICE_UNKNOWN`,
      bvdDevice = 0x0500 : `FT_DEVICE_2232`,
      bvdDevice = 0x0600 : `FT_DEVICE_232R`,
      bvdDevice = 0x0600 : `FT_DEVICE_245R`,
      bvdDevice = 0x0700 : `FT_DEVICE_2232H`,
      bvdDevice = 0x0800 : `FT_DEVICE_4232H`,
      bvdDevice = 0x0900 : `FT_DEVICE_232H`,
      bvdDevice = 0x1000 : `FT_DEVICE_X_SERIES`
      bvdDevice = 0x1800 : `#FT_DEVICE_4222`
      bvdDevice = 0x1900 : `#FT_DEVICE_4222`
      bvdDevice = 0x1700 : `#FT_DEVICE_4222`
      See Also:
        Constant Field Values

    - #### FT_DEVICE_2232

          public static final int FT_DEVICE_2232

      Device Type :
      bvdDevice = 0x0200 or 0x0400 and iSerialNumber != 0: `FT_DEVICE_232B`,
      bvdDevice = 0x0200 and iSerialNumber != 0 : `FT_DEVICE_8U232AM`,
      Unknown : `FT_DEVICE_UNKNOWN`,
      bvdDevice = 0x0500 : `FT_DEVICE_2232`,
      bvdDevice = 0x0600 : `FT_DEVICE_232R`,
      bvdDevice = 0x0600 : `FT_DEVICE_245R`,
      bvdDevice = 0x0700 : `FT_DEVICE_2232H`,
      bvdDevice = 0x0800 : `FT_DEVICE_4232H`,
      bvdDevice = 0x0900 : `FT_DEVICE_232H`,
      bvdDevice = 0x1000 : `FT_DEVICE_X_SERIES`
      bvdDevice = 0x1800 : `#FT_DEVICE_4222`
      bvdDevice = 0x1900 : `#FT_DEVICE_4222`
      bvdDevice = 0x1700 : `#FT_DEVICE_4222`
      See Also:
        Constant Field Values

    - #### FT_DEVICE_232R

          public static final int FT_DEVICE_232R

      Device Type :
      bvdDevice = 0x0200 or 0x0400 and iSerialNumber != 0: `FT_DEVICE_232B`,
      bvdDevice = 0x0200 and iSerialNumber != 0 : `FT_DEVICE_8U232AM`,
      Unknown : `FT_DEVICE_UNKNOWN`,
      bvdDevice = 0x0500 : `FT_DEVICE_2232`,
      bvdDevice = 0x0600 : `FT_DEVICE_232R`,
      bvdDevice = 0x0600 : `FT_DEVICE_245R`,
      bvdDevice = 0x0700 : `FT_DEVICE_2232H`,
      bvdDevice = 0x0800 : `FT_DEVICE_4232H`,
      bvdDevice = 0x0900 : `FT_DEVICE_232H`,
      bvdDevice = 0x1000 : `FT_DEVICE_X_SERIES`
      bvdDevice = 0x1800 : `#FT_DEVICE_4222`
      bvdDevice = 0x1900 : `#FT_DEVICE_4222`
      bvdDevice = 0x1700 : `#FT_DEVICE_4222`
      See Also:
        Constant Field Values

    - #### FT_DEVICE_245R

          public static final int FT_DEVICE_245R

      Device Type :
      bvdDevice = 0x0200 or 0x0400 and iSerialNumber != 0: `FT_DEVICE_232B`,
      bvdDevice = 0x0200 and iSerialNumber != 0 : `FT_DEVICE_8U232AM`,
      Unknown : `FT_DEVICE_UNKNOWN`,
      bvdDevice = 0x0500 : `FT_DEVICE_2232`,
      bvdDevice = 0x0600 : `FT_DEVICE_232R`,
      bvdDevice = 0x0600 : `FT_DEVICE_245R`,
      bvdDevice = 0x0700 : `FT_DEVICE_2232H`,
      bvdDevice = 0x0800 : `FT_DEVICE_4232H`,
      bvdDevice = 0x0900 : `FT_DEVICE_232H`,
      bvdDevice = 0x1000 : `FT_DEVICE_X_SERIES`
      bvdDevice = 0x1800 : `#FT_DEVICE_4222`
      bvdDevice = 0x1900 : `#FT_DEVICE_4222`
      bvdDevice = 0x1700 : `#FT_DEVICE_4222`
      See Also:
        Constant Field Values

    - #### FT_DEVICE_2232H

          public static final int FT_DEVICE_2232H

      Device Type :
      bvdDevice = 0x0200 or 0x0400 and iSerialNumber != 0: `FT_DEVICE_232B`,
      bvdDevice = 0x0200 and iSerialNumber != 0 : `FT_DEVICE_8U232AM`,
      Unknown : `FT_DEVICE_UNKNOWN`,
      bvdDevice = 0x0500 : `FT_DEVICE_2232`,
      bvdDevice = 0x0600 : `FT_DEVICE_232R`,
      bvdDevice = 0x0600 : `FT_DEVICE_245R`,
      bvdDevice = 0x0700 : `FT_DEVICE_2232H`,
      bvdDevice = 0x0800 : `FT_DEVICE_4232H`,
      bvdDevice = 0x0900 : `FT_DEVICE_232H`,
      bvdDevice = 0x1000 : `FT_DEVICE_X_SERIES`
      bvdDevice = 0x1800 : `#FT_DEVICE_4222`
      bvdDevice = 0x1900 : `#FT_DEVICE_4222`
      bvdDevice = 0x1700 : `#FT_DEVICE_4222`
      See Also:
        Constant Field Values

    - #### FT_DEVICE_4232H

          public static final int FT_DEVICE_4232H

      Device Type :
      bvdDevice = 0x0200 or 0x0400 and iSerialNumber != 0: `FT_DEVICE_232B`,
      bvdDevice = 0x0200 and iSerialNumber != 0 : `FT_DEVICE_8U232AM`,
      Unknown : `FT_DEVICE_UNKNOWN`,
      bvdDevice = 0x0500 : `FT_DEVICE_2232`,
      bvdDevice = 0x0600 : `FT_DEVICE_232R`,
      bvdDevice = 0x0600 : `FT_DEVICE_245R`,
      bvdDevice = 0x0700 : `FT_DEVICE_2232H`,
      bvdDevice = 0x0800 : `FT_DEVICE_4232H`,
      bvdDevice = 0x0900 : `FT_DEVICE_232H`,
      bvdDevice = 0x1000 : `FT_DEVICE_X_SERIES`
      bvdDevice = 0x1800 : `#FT_DEVICE_4222`
      bvdDevice = 0x1900 : `#FT_DEVICE_4222`
      bvdDevice = 0x1700 : `#FT_DEVICE_4222`
      See Also:
        Constant Field Values

    - #### FT_DEVICE_232H

          public static final int FT_DEVICE_232H

      Device Type :
      bvdDevice = 0x0200 or 0x0400 and iSerialNumber != 0: `FT_DEVICE_232B`,
      bvdDevice = 0x0200 and iSerialNumber != 0 : `FT_DEVICE_8U232AM`,
      Unknown : `FT_DEVICE_UNKNOWN`,
      bvdDevice = 0x0500 : `FT_DEVICE_2232`,
      bvdDevice = 0x0600 : `FT_DEVICE_232R`,
      bvdDevice = 0x0600 : `FT_DEVICE_245R`,
      bvdDevice = 0x0700 : `FT_DEVICE_2232H`,
      bvdDevice = 0x0800 : `FT_DEVICE_4232H`,
      bvdDevice = 0x0900 : `FT_DEVICE_232H`,
      bvdDevice = 0x1000 : `FT_DEVICE_X_SERIES`
      bvdDevice = 0x1800 : `#FT_DEVICE_4222`
      bvdDevice = 0x1900 : `#FT_DEVICE_4222`
      bvdDevice = 0x1700 : `#FT_DEVICE_4222`
      See Also:
        Constant Field Values

    - #### FT_DEVICE_X_SERIES

          public static final int FT_DEVICE_X_SERIES

      Device Type :
      bvdDevice = 0x0200 or 0x0400 and iSerialNumber != 0: `FT_DEVICE_232B`,
      bvdDevice = 0x0200 and iSerialNumber != 0 : `FT_DEVICE_8U232AM`,
      Unknown : `FT_DEVICE_UNKNOWN`,
      bvdDevice = 0x0500 : `FT_DEVICE_2232`,
      bvdDevice = 0x0600 : `FT_DEVICE_232R`,
      bvdDevice = 0x0600 : `FT_DEVICE_245R`,
      bvdDevice = 0x0700 : `FT_DEVICE_2232H`,
      bvdDevice = 0x0800 : `FT_DEVICE_4232H`,
      bvdDevice = 0x0900 : `FT_DEVICE_232H`,
      bvdDevice = 0x1000 : `FT_DEVICE_X_SERIES`
      bvdDevice = 0x1800 : `#FT_DEVICE_4222`
      bvdDevice = 0x1900 : `#FT_DEVICE_4222`
      bvdDevice = 0x1700 : `#FT_DEVICE_4222`
      See Also:
        Constant Field Values

    - #### FT_DEVICE_4222_0

          public static final int FT_DEVICE_4222_0

      Device Type :
      bvdDevice = 0x0200 or 0x0400 and iSerialNumber != 0: `FT_DEVICE_232B`,
      bvdDevice = 0x0200 and iSerialNumber != 0 : `FT_DEVICE_8U232AM`,
      Unknown : `FT_DEVICE_UNKNOWN`,
      bvdDevice = 0x0500 : `FT_DEVICE_2232`,
      bvdDevice = 0x0600 : `FT_DEVICE_232R`,
      bvdDevice = 0x0600 : `FT_DEVICE_245R`,
      bvdDevice = 0x0700 : `FT_DEVICE_2232H`,
      bvdDevice = 0x0800 : `FT_DEVICE_4232H`,
      bvdDevice = 0x0900 : `FT_DEVICE_232H`,
      bvdDevice = 0x1000 : `FT_DEVICE_X_SERIES`
      bvdDevice = 0x1800 : `#FT_DEVICE_4222`
      bvdDevice = 0x1900 : `#FT_DEVICE_4222`
      bvdDevice = 0x1700 : `#FT_DEVICE_4222`
      See Also:
        Constant Field Values

    - #### FT_DEVICE_4222_1_2

          public static final int FT_DEVICE_4222_1_2

      Device Type :
      bvdDevice = 0x0200 or 0x0400 and iSerialNumber != 0: `FT_DEVICE_232B`,
      bvdDevice = 0x0200 and iSerialNumber != 0 : `FT_DEVICE_8U232AM`,
      Unknown : `FT_DEVICE_UNKNOWN`,
      bvdDevice = 0x0500 : `FT_DEVICE_2232`,
      bvdDevice = 0x0600 : `FT_DEVICE_232R`,
      bvdDevice = 0x0600 : `FT_DEVICE_245R`,
      bvdDevice = 0x0700 : `FT_DEVICE_2232H`,
      bvdDevice = 0x0800 : `FT_DEVICE_4232H`,
      bvdDevice = 0x0900 : `FT_DEVICE_232H`,
      bvdDevice = 0x1000 : `FT_DEVICE_X_SERIES`
      bvdDevice = 0x1800 : `#FT_DEVICE_4222`
      bvdDevice = 0x1900 : `#FT_DEVICE_4222`
      bvdDevice = 0x1700 : `#FT_DEVICE_4222`
      See Also:
        Constant Field Values

    - #### FT_DEVICE_4222_3

          public static final int FT_DEVICE_4222_3

      Device Type :
      bvdDevice = 0x0200 or 0x0400 and iSerialNumber != 0: `FT_DEVICE_232B`,
      bvdDevice = 0x0200 and iSerialNumber != 0 : `FT_DEVICE_8U232AM`,
      Unknown : `FT_DEVICE_UNKNOWN`,
      bvdDevice = 0x0500 : `FT_DEVICE_2232`,
      bvdDevice = 0x0600 : `FT_DEVICE_232R`,
      bvdDevice = 0x0600 : `FT_DEVICE_245R`,
      bvdDevice = 0x0700 : `FT_DEVICE_2232H`,
      bvdDevice = 0x0800 : `FT_DEVICE_4232H`,
      bvdDevice = 0x0900 : `FT_DEVICE_232H`,
      bvdDevice = 0x1000 : `FT_DEVICE_X_SERIES`
      bvdDevice = 0x1800 : `#FT_DEVICE_4222`
      bvdDevice = 0x1900 : `#FT_DEVICE_4222`
      bvdDevice = 0x1700 : `#FT_DEVICE_4222`
      See Also:
        Constant Field Values

    - #### FT_BITMODE_RESET

          public static final byte FT_BITMODE_RESET

      Bit Mode bits :
      Reset: `FT_BITMODE_RESET`,
      Asynchronous Bit Bang (FT232B, FT2232, FT232H, FT2232H, FT4232H): `FT_BITMODE_ASYNC_BITBANG`,
      MPSSE (FT2232, FT2232H, FT4232H and FT232H devices only) : `FT_BITMODE_MPSSE`,
      Synchronous Bit Bang (FT232R, FT245R, FT2232, FT2232H, FT4232H and FT232H devices only) : `FT_BITMODE_SYNC_BITBANG`,
      MCU Host Bus Emulation Mode (FT2232, FT2232H, and FT232H devices only) : `FT_BITMODE_MCU_HOST`,
      Fast Opto-Isolated Serial Mode (FT2232, FT2232H, and FT232H devices only) : `FT_BITMODE_FAST_SERIAL`,
      CBUS Bit Bang Mode (FT232R and FT232H devices only) : `FT_BITMODE_CBUS_BITBANG`,
      Single Channel Synchronous 245 FIFO Mode (FT2232H and FT232H devices only) : `FT_BITMODE_SYNC_FIFO`
      See Also:
        Constant Field Values

    - #### FT_BITMODE_ASYNC_BITBANG

          public static final byte FT_BITMODE_ASYNC_BITBANG

      Bit Mode bits :
      Reset: `FT_BITMODE_RESET`,
      Asynchronous Bit Bang (FT232B, FT2232, FT232H, FT2232H, FT4232H): `FT_BITMODE_ASYNC_BITBANG`,
      MPSSE (FT2232, FT2232H, FT4232H and FT232H devices only) : `FT_BITMODE_MPSSE`,
      Synchronous Bit Bang (FT232R, FT245R, FT2232, FT2232H, FT4232H and FT232H devices only) : `FT_BITMODE_SYNC_BITBANG`,
      MCU Host Bus Emulation Mode (FT2232, FT2232H, and FT232H devices only) : `FT_BITMODE_MCU_HOST`,
      Fast Opto-Isolated Serial Mode (FT2232, FT2232H, and FT232H devices only) : `FT_BITMODE_FAST_SERIAL`,
      CBUS Bit Bang Mode (FT232R and FT232H devices only) : `FT_BITMODE_CBUS_BITBANG`,
      Single Channel Synchronous 245 FIFO Mode (FT2232H and FT232H devices only) : `FT_BITMODE_SYNC_FIFO`
      See Also:
        Constant Field Values

    - #### FT_BITMODE_MPSSE

          public static final byte FT_BITMODE_MPSSE

      Bit Mode bits :
      Reset: `FT_BITMODE_RESET`,
      Asynchronous Bit Bang (FT232B, FT2232, FT232H, FT2232H, FT4232H): `FT_BITMODE_ASYNC_BITBANG`,
      MPSSE (FT2232, FT2232H, FT4232H and FT232H devices only) : `FT_BITMODE_MPSSE`,
      Synchronous Bit Bang (FT232R, FT245R, FT2232, FT2232H, FT4232H and FT232H devices only) : `FT_BITMODE_SYNC_BITBANG`,
      MCU Host Bus Emulation Mode (FT2232, FT2232H, and FT232H devices only) : `FT_BITMODE_MCU_HOST`,
      Fast Opto-Isolated Serial Mode (FT2232, FT2232H, and FT232H devices only) : `FT_BITMODE_FAST_SERIAL`,
      CBUS Bit Bang Mode (FT232R and FT232H devices only) : `FT_BITMODE_CBUS_BITBANG`,
      Single Channel Synchronous 245 FIFO Mode (FT2232H and FT232H devices only) : `FT_BITMODE_SYNC_FIFO`
      See Also:
        Constant Field Values

    - #### FT_BITMODE_SYNC_BITBANG

          public static final byte FT_BITMODE_SYNC_BITBANG

      Bit Mode bits :
      Reset: `FT_BITMODE_RESET`,
      Asynchronous Bit Bang (FT232B, FT2232, FT232H, FT2232H, FT4232H): `FT_BITMODE_ASYNC_BITBANG`,
      MPSSE (FT2232, FT2232H, FT4232H and FT232H devices only) : `FT_BITMODE_MPSSE`,
      Synchronous Bit Bang (FT232R, FT245R, FT2232, FT2232H, FT4232H and FT232H devices only) : `FT_BITMODE_SYNC_BITBANG`,
      MCU Host Bus Emulation Mode (FT2232, FT2232H, and FT232H devices only) : `FT_BITMODE_MCU_HOST`,
      Fast Opto-Isolated Serial Mode (FT2232, FT2232H, and FT232H devices only) : `FT_BITMODE_FAST_SERIAL`,
      CBUS Bit Bang Mode (FT232R and FT232H devices only) : `FT_BITMODE_CBUS_BITBANG`,
      Single Channel Synchronous 245 FIFO Mode (FT2232H and FT232H devices only) : `FT_BITMODE_SYNC_FIFO`
      See Also:
        Constant Field Values

    - #### FT_BITMODE_MCU_HOST

          public static final byte FT_BITMODE_MCU_HOST

      Bit Mode bits :
      Reset: `FT_BITMODE_RESET`,
      Asynchronous Bit Bang (FT232B, FT2232, FT232H, FT2232H, FT4232H): `FT_BITMODE_ASYNC_BITBANG`,
      MPSSE (FT2232, FT2232H, FT4232H and FT232H devices only) : `FT_BITMODE_MPSSE`,
      Synchronous Bit Bang (FT232R, FT245R, FT2232, FT2232H, FT4232H and FT232H devices only) : `FT_BITMODE_SYNC_BITBANG`,
      MCU Host Bus Emulation Mode (FT2232, FT2232H, and FT232H devices only) : `FT_BITMODE_MCU_HOST`,
      Fast Opto-Isolated Serial Mode (FT2232, FT2232H, and FT232H devices only) : `FT_BITMODE_FAST_SERIAL`,
      CBUS Bit Bang Mode (FT232R and FT232H devices only) : `FT_BITMODE_CBUS_BITBANG`,
      Single Channel Synchronous 245 FIFO Mode (FT2232H and FT232H devices only) : `FT_BITMODE_SYNC_FIFO`
      See Also:
        Constant Field Values

    - #### FT_BITMODE_FAST_SERIAL

          public static final byte FT_BITMODE_FAST_SERIAL

      Bit Mode bits :
      Reset: `FT_BITMODE_RESET`,
      Asynchronous Bit Bang (FT232B, FT2232, FT232H, FT2232H, FT4232H): `FT_BITMODE_ASYNC_BITBANG`,
      MPSSE (FT2232, FT2232H, FT4232H and FT232H devices only) : `FT_BITMODE_MPSSE`,
      Synchronous Bit Bang (FT232R, FT245R, FT2232, FT2232H, FT4232H and FT232H devices only) : `FT_BITMODE_SYNC_BITBANG`,
      MCU Host Bus Emulation Mode (FT2232, FT2232H, and FT232H devices only) : `FT_BITMODE_MCU_HOST`,
      Fast Opto-Isolated Serial Mode (FT2232, FT2232H, and FT232H devices only) : `FT_BITMODE_FAST_SERIAL`,
      CBUS Bit Bang Mode (FT232R and FT232H devices only) : `FT_BITMODE_CBUS_BITBANG`,
      Single Channel Synchronous 245 FIFO Mode (FT2232H and FT232H devices only) : `FT_BITMODE_SYNC_FIFO`
      See Also:
        Constant Field Values

    - #### FT_BITMODE_CBUS_BITBANG

          public static final byte FT_BITMODE_CBUS_BITBANG

      Bit Mode bits :
      Reset: `FT_BITMODE_RESET`,
      Asynchronous Bit Bang (FT232B, FT2232, FT232H, FT2232H, FT4232H): `FT_BITMODE_ASYNC_BITBANG`,
      MPSSE (FT2232, FT2232H, FT4232H and FT232H devices only) : `FT_BITMODE_MPSSE`,
      Synchronous Bit Bang (FT232R, FT245R, FT2232, FT2232H, FT4232H and FT232H devices only) : `FT_BITMODE_SYNC_BITBANG`,
      MCU Host Bus Emulation Mode (FT2232, FT2232H, and FT232H devices only) : `FT_BITMODE_MCU_HOST`,
      Fast Opto-Isolated Serial Mode (FT2232, FT2232H, and FT232H devices only) : `FT_BITMODE_FAST_SERIAL`,
      CBUS Bit Bang Mode (FT232R and FT232H devices only) : `FT_BITMODE_CBUS_BITBANG`,
      Single Channel Synchronous 245 FIFO Mode (FT2232H and FT232H devices only) : `FT_BITMODE_SYNC_FIFO`
      See Also:
        Constant Field Values

    - #### FT_BITMODE_SYNC_FIFO

          public static final byte FT_BITMODE_SYNC_FIFO

      Bit Mode bits :
      Reset: `FT_BITMODE_RESET`,
      Asynchronous Bit Bang (FT232B, FT2232, FT232H, FT2232H, FT4232H): `FT_BITMODE_ASYNC_BITBANG`,
      MPSSE (FT2232, FT2232H, FT4232H and FT232H devices only) : `FT_BITMODE_MPSSE`,
      Synchronous Bit Bang (FT232R, FT245R, FT2232, FT2232H, FT4232H and FT232H devices only) : `FT_BITMODE_SYNC_BITBANG`,
      MCU Host Bus Emulation Mode (FT2232, FT2232H, and FT232H devices only) : `FT_BITMODE_MCU_HOST`,
      Fast Opto-Isolated Serial Mode (FT2232, FT2232H, and FT232H devices only) : `FT_BITMODE_FAST_SERIAL`,
      CBUS Bit Bang Mode (FT232R and FT232H devices only) : `FT_BITMODE_CBUS_BITBANG`,
      Single Channel Synchronous 245 FIFO Mode (FT2232H and FT232H devices only) : `FT_BITMODE_SYNC_FIFO`
      See Also:
        Constant Field Values

    - #### FTDI_BREAK_OFF

          public static final int FTDI_BREAK_OFF

      BREAK on is bit 14 in wValue parameter of FTDI_SET_DATA request :
      UART break on condition: `FTDI_BREAK_OFF`,
      UART break off condition: `FTDI_BREAK_ON`
      See Also:
        Constant Field Values

    - #### FTDI_BREAK_ON

          public static final int FTDI_BREAK_ON

      BREAK on is bit 14 in wValue parameter of FTDI_SET_DATA request :
      UART break on condition: `FTDI_BREAK_OFF`,
      UART break off condition: `FTDI_BREAK_ON`
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### isFtDevice

          public boolean isFtDevice(UsbDevice dev)

      This queries if a plugged-in USB device is a valid FT_Device
      Parameters:
        `dev` - The UsbDevice get from ACTION_USB_DEVICE_ATTACHED broadcast.
      Returns:
        If the plugged in USB device is ascertained to be a valid FT device, the query returns a ¡¥true¡¦ value

    - #### getInstance

          public static D2xxManager getInstance(Context parentContext)
                                         throws D2xxManager.D2xxException

      This method initialises an application, obtaining a value of D2xx device manager.
      Parameters:
        `parentContext` - The calling activity must pass the application Context into this function.
      Returns:
        An instance of `D2xxManager` device manager.
      Throws:
        `D2xxManager.D2xxException`

    - #### setVIDPID

          public boolean setVIDPID(int vendorId,
                          int productId)

      This allows a custom VID and PID combination within the internal device list table. This loads the drivers for the specified VID and PID combination. NOTE: The driver supports a limited set of VID and PID matched devices. VID : 0x0403 , FTDI PID : 0x6015 , X Series Device PID : 0x6014 , FT232H Device PID : 0x6011 , FT4232H Device PID : 0x6010 , FT2232 or FT2232H Device PID : 0x6001 , 232AM, FT232B or FT232R PID : 0x6006 , Direct Driver Recovery PID PID : 0x601C , FT4222 PID : 0xFAC1 , USB Instruments PS40M10 PID : 0xFAC2 , USB Instruments DS1M12 PID : 0xFAC3 , USB Instruments DS100M10 PID : 0xFAC4 , USB Instruments DS60M10 PID : 0xFAC5 , USB Instruments EasySYNC LA100 PID : 0xFAC6 , USB2-F-7x01 CANPlus Adapter PID : 0x6012 , ES001H PID : 0x1025 , Macraigor - customer request PID : 0x0001 , Keith Support Request 8/10/04 PID : 0x6017 , Additional VID/PID To use this driver with other VID and PID combinations, the `setVIDPID(int, int)` function is a pre-requisite. `openByIndex(Context, int, com.ftdi.j2xx.D2xxManager.DriverParameters)`, `openByLocation(Context, int, com.ftdi.j2xx.D2xxManager.DriverParameters)`, `openBySerialNumber(Context, java.lang.String, com.ftdi.j2xx.D2xxManager.DriverParameters)`, `openByDescription(Context, java.lang.String, com.ftdi.j2xx.D2xxManager.DriverParameters)`, `createDeviceInfoList(Context)`.
      Parameters:
        `vendorId` - The vendor ID that the driver aligns with
        `productId` - The product ID that the driver aligns with
      Returns:
        If success , return true.

    - #### getVIDPID

          public int[][] getVIDPID()

      This retrieves the current VID and PID combination from within the internal device list table. The VID and PID can be matched using `setVIDPID(int, int)`
      Returns:
        2-element array containing the VID in the first element and the PID in the second element.

    - #### createDeviceInfoList

          public int createDeviceInfoList(Context parentContext)

      This method builds an internal device information list and returns the number of D2XX devices connected to the system. The list contains information about both unopened and opened devices. Device information may be retrieved via the `getDeviceInfoList(int, com.ftdi.j2xx.D2xxManager.FtDeviceInfoListNode[])` or `getDeviceInfoListDetail(int)` methods. Remarks: An application can use this function to ascertain the number of devices attached to the system. The application allocates space for the device information list and retrieves the list using `getDeviceInfoList(int, com.ftdi.j2xx.D2xxManager.FtDeviceInfoListNode[])` or `getDeviceInfoListDetail(int)` methods. If the devices connected to the system change, the device info list will not be updated until `createDeviceInfoList(Context)` is called again.
      Parameters:
        `parentContext` - The calling activity must pass the application Context into this function.
      Returns:
        The number of devices represented in the device information list. This is used to ensure that sufficient storage for the device list is returned by `getDeviceInfoList(int, com.ftdi.j2xx.D2xxManager.FtDeviceInfoListNode[])`.

    - #### getDeviceInfoList

          public int getDeviceInfoList(int numDevs,
                              D2xxManager.FtDeviceInfoListNode[] deviceList)

      This method returns the device list created with a prior call to `createDeviceInfoList(Context)`. The list contains all available information for all of the available devices at the time that `createDeviceInfoList(Context)` was called. Note that the flags element of each `D2xxManager.FtDeviceInfoListNode` object in the list is a bit-mask of `FT_FLAGS_OPENED` and `FT_FLAGS_HI_SPEED`. Remarks: This function should only be called after calling `createDeviceInfoList(Context)`. If the devices connected to the system change, the device info list will not be updated until `createDeviceInfoList(Context)` is called again. Location ID information is not returned for devices that are open when `createDeviceInfoList(Context)` is called. Information is not available for devices which are open in other processes. The Flags parameter of the `FT_FLAGS_OPENED` indicate that the device is open, but other fields will be unpopulated.
      Parameters:
        `numDevs` - The number of devices represented in the device information list.
        `deviceList` - An array of `D2xxManager.FtDeviceInfoListNode`. That contains information on all available devices after a successful call..
      Returns:
        The number of devices represented in the device information list as returned from the `getDeviceInfoList(int, com.ftdi.j2xx.D2xxManager.FtDeviceInfoListNode[])` call.

    - #### getDeviceInfoListDetail

          public D2xxManager.FtDeviceInfoListNode getDeviceInfoListDetail(int index)

      This method returns information for a single device from the internal device list created by a previous call to `createDeviceInfoList(Context)`. The flags element of the `D2xxManager.FtDeviceInfoListNode` object is a bit-mask of `FT_FLAGS_OPENED` and `FT_FLAGS_HI_SPEED`. NOTE:This function is to be called after calling `createDeviceInfoList(Context)`. The device info list is not updated where changes are made to the connected devices until `createDeviceInfoList(Context)` is called again. The index value is zero-based.
      Parameters:
        `index` - An index of the information pertaining to the devices in the list.
      Returns:
        A `D2xxManager.FtDeviceInfoListNode` object containing the information available for the device specified index in the list. NULL for error.

    - #### getLibraryVersion

          public static int getLibraryVersion()

      This method returns the D2XX library version number.
      Returns:
        A 32-bit number representing the library version in binary coded decimal format.

    - #### openByUsbDevice

          public FT_Device openByUsbDevice(Context parentContext,
                                  UsbDevice dev,
                                  D2xxManager.DriverParameters params)

      This designates the device from the specified USB Device object, and allows for configuration of driver parameters.
      Parameters:
        `parentContext` - The calling activity must pass the application Context into this function.
        `dev` - The USB Device object as an FT_Device
        `DriverParameters` - Parameters to configure max transfer size, buffer size, Rx timeout and number of buffers. Buffer size : the default is 16k , Max is 16k , Min is 64. Packet size : the default is 16384 , Max is 16384 , Min is 64. Buffer Number : the default is 16 , Max is 16 , Min is 2.
      Returns:
        A `FT_Device` object containing the device object, NULL for error

    - #### openByUsbDevice

          public FT_Device openByUsbDevice(Context parentContext,
                                  UsbDevice dev)

      This designates the device from the specified USB Device object..
      Parameters:
        `parentContext` - The calling activity must pass the application Context into this function.
        `dev` - The USB Device object as an FT_Device
      Returns:
        A `FT_Device` object containing the device object, NULL for error

    - #### openByIndex

          public FT_Device openByIndex(Context parentContext,
                              int index,
                              D2xxManager.DriverParameters params)

      This designates the device at the specified index and allows for configuration of driver parameters.
      Parameters:
        `parentContext` - The calling activity must pass the application Context into this function.
        `index` - The index of the device, which is 0 based..
        `DriverParameters` - Parameters to configure max transfer size, buffer size, Rx timeout and number of buffers. Buffer size : the default is 16k , Max is 16k , Min is 64. Packet size : the default is 16384 , Max is 16384 , Min is 64. Buffer Number : the default is 16 , Max is 16 , Min is 2.
      Returns:
        A `FT_Device` object containing the device object, NULL for error

    - #### openByIndex

          public FT_Device openByIndex(Context parentContext,
                              int index)

      This designates the device at the specified index.
      Parameters:
        `parentContext` - The calling activity must pass the application Context into this function.
        `index` - The index of the device, which is 0 based..
      Returns:
        A `FT_Device` object containing the device object, NULL for error

    - #### openBySerialNumber

          public FT_Device openBySerialNumber(Context parentContext,
                                     java.lang.String serialNumber,
                                     D2xxManager.DriverParameters params)

      This designates the device with the specified serial number for use, and allows for configuration of driver parameters.
      Parameters:
        `parentContext` - The calling activity must pass the application Context into this function.
        `serialNumber` - The serial number of the device.
        `DriverParameters` - Parameters to configure max transfer size, buffer size, Rx timeout and number of buffers. Buffer size : the default is 16k , Max is 16k , Min is 64. Packet size : the default is 16384 , Max is 16384 , Min is 64. Buffer Number : the default is 16 , Max is 16 , Min is 2.
      Returns:
        A `FT_Device` object containing the device object, NULL for error

    - #### openBySerialNumber

          public FT_Device openBySerialNumber(Context parentContext,
                                     java.lang.String serialNumber)

      This designates the device with the specified serial number.
      Parameters:
        `parentContext` - The calling activity must pass the application Context into this function.
        `serialNumber` - The serial number of the device.
      Returns:
        A `FT_Device` object containing the device object, NULL for error

    - #### openByDescription

          public FT_Device openByDescription(Context parentContext,
                                    java.lang.String description,
                                    D2xxManager.DriverParameters params)

      This designates the device with the specified description and allows for configuration of driver parameters.
      Parameters:
        `parentContext` - The calling activity must pass the application Context into this function..
        `description` - Description of the device.
        `DriverParameters` - Parameters to configure max transfer size, buffer size, Rx timeout and number of buffers. Buffer size : the default is 16k , Max is 16k , Min is 64. Packet size : the default is 16384 , Max is 16384 , Min is 64. Buffer Number : the default is 16 , Max is 16 , Min is 2.
      Returns:
        A `FT_Device` object containing the device object, NULL for error

    - #### openByDescription

          public FT_Device openByDescription(Context parentContext,
                                    java.lang.String description)

      This designates the device with the specified description.
      Parameters:
        `parentContext` - The calling activity must pass the application Context into this function.
        `description` - Description of the device.
      Returns:
        A `FT_Device` object containing the device object, NULL for error

    - #### openByLocation

          public FT_Device openByLocation(Context parentContext,
                                 int location,
                                 D2xxManager.DriverParameters params)

      This designates the device at the specified location, and allows for configuration of driver parameters.
      Parameters:
        `parentContext` - The calling activity must pass the application Context into this function.
        `location` - The location of the device.
        `DriverParameters` - Parameters to configure max packet size, buffer size, Rx timeout and number of buffers. Buffer size : the default is 16k , Max is 16k , Min is 64. Packet size : the default is 16384 , Max is 16384 , Min is 64. Buffer Number : the default is 16 , Max is 16 , Min is 2.
      Returns:
        A `FT_Device` object containing the device object, NULL for error

    - #### openByLocation

          public FT_Device openByLocation(Context parentContext,
                                 int location)

      This designates the device at the specified location.
      Parameters:
        `parentContext` - The calling activity must pass the application Context into this function.
        `location` - The location of the device.
      Returns:
        A `FT_Device` object containing the device object, NULL for error

    - #### addUsbDevice

          public int addUsbDevice(UsbDevice dev)

      This method analyze the dev passed-in, if it's a FTDI device, add it to manageable device list
      Parameters:
        `dev` - The UsbDevice obtained from Android USB API or Broadcast message
      Returns:
        The number of total interfaces added into internal managed device list

About FTDI | FTDI Licence Terms